#!/bin/bash


#-------------------------
cmdName=ChangeTempo
cmdVersion="1.0.0.0 2010-04-20"
#-------------------------

#-------------------------
cmdhelp()
{
echo ""
echo "$cmdName -input signal -output f0data -t type -tempo temp"
echo ""
} >/dev/stderr
#-------------------------

#-------------------------
error()
{
$PHONEDITPATH/plugins/DlgPrompt.exe "Syntax error : $errmsg"
echo ""
echo "Syntax error : $errmsg"
cmdhelp

} >/dev/stderr


#-------------------------
# Arguments analysis
#-------------------------
lcmd=$@
step=10
format='raw'
while test "X$1" != X
do
	case $1 in
	-in*)  input="$2" ; shift 2 ;;
	-out*) output="$2" ; shift 2 ;;
    -tempo) tempo=$2 ; shift 2 ;;
	-t|-type) format=$2 ; shift 2 ;;
	-help|-h|-sos|-aide) cmdhelp ; exit 0 ;;
	-*)         errmsg="Unknown Argument $1" ; error; exit 1 ;;
	esac
done

#-------------------------
# Input descriptor
#-------------------------
if [ $format == 'raw' ]; then
dsc_input=$input.dsc
if test  ! -f "$dsc_input"
then
  echo "Descriptor file $dsc_input non available" >/dev/stderr
  cmdhelp
  exit 1
fi

sampling=$(GetParamFromDesc SAMPLING_RATE < "$dsc_input")

BitSampleSize=$(GetParamFromDesc SRC_BITSPERSAMPLE < "$dsc_input")
sampleSize=$(($BitSampleSize / 8))

#-------------------------
# JOB
#-------------------------

sox -t $format -$sampleSize -s -r $sampling $input -t $format $output tempo $tempo
else
sox -t $format $input -t $format $output tempo $tempo
fi
#		  
#-------------------------
# Output descriptor
#-------------------------
if [ $format == 'raw' ]; then
fsize=$(stat -c%s "$output")
datacount=$(($fsize / 2))
NChannels=$(GetParamFromDesc SRC_NCHANNELS < "$dsc_input")

{
echo "[CODING]"
echo "CODING_version="$cmdVersion
echo "[SETTINGS]"
echo "DATA_NAME=Waveform"
echo "DATA_TYPE=temporal_serie"
echo "DATA_VAR_FORMAT=int16_intel"
echo "ACRONYM='wave'"
echo "DATA_COUNT="$datacount
echo "FRAME_SIZE="$size
echo "SAMPLING_RATE="$sampling
echo "[SCALE]"
echo "UNIT=Hz"
echo "[INFO]"
echo "SOURCE="$input
echo "SRC_RATE="$sampling
echo "SRC_BITSPERSAMPLE="$BitSampleSize
echo "SRC_NCHANNELS="$NChannels
echo "CREATION_DATE="$(date)
echo "SOFTWARE="$cmdName $cmdVersion
echo "COPYRIGHT=Copyright  2010 - LPL"
echo "OPTIONS=-newSample "$newstep
echo "COMMAND=" $cmdName $lcmd
} > $output.dsc

fi