#!/bin/bash


#-------------------------
cmdName=Contact_On
cmdVersion="1.0.0.0 2010-04-20"
#-------------------------

#-------------------------
cmdhelp()
{
$PHONEDITPATH/plugins/DlgPrompt.exe "Syntax error : $errmsg"
echo ""
echo "$cmdName -input signal -output f0data [-Pourcent pc] [-Zone complet|ant|post]"
echo ""
} >/dev/stderr
#-------------------------

#-------------------------
error()
{
echo ""
echo "Syntax error : $errmsg"
cmdhelp

} >/dev/stderr
#-------------------------

#-------------------------
# Arguments analysis
#-------------------------
lcmd=$@
zone='complet'
format='brut'
step=4

while test "X$1" != X
do
   case "$1" in
   -in*)  input="$2" ; shift 2 ;;
   -out*) output="$2" ; shift 2 ;;
   -txtfc) textFile=$2; shift 2 ;;
   -P|-Pourcent) format='pc' ; shift 1 ;;
   -Z|-Zone) zone=$2; shift 2;;
   -help|-h|-sos|-aide) cmdhelp ; exit 0 ;;
   -*)         errmsg="Unknown Argument $1" ; error; exit 1 ;;
   esac
done

#textFile=$input'.txt'



#-------------------------
# Input descriptor
#-------------------------
dsc_input=$input.dsc
if test  ! -f "$dsc_input"
then
  echo "Descriptor file $dsc_input non available" >/dev/stderr
  errmsg="Descriptor file $dsc_input non available"
  cmdhelp
  exit 1
fi

sampling=$(GetParamFromDesc SAMPLING_RATE < "$dsc_input")
#form=$(GetParamFromDesc SRC_FORM < "$dsc_input")
#sec=$(echo $form | cut -d\| -f4 | cut -d' ' -f2)
#step=$($sec/$datacount)

#-------------------------
# JOB
#-------------------------

# PATH est configure ds bash_profile

#DataEpgRawToAsciiVector -input $input -output $textFile

if [ $zone == 'ant' ]
then
	textFileAnt=$input'_ant.txt'
	tr -s  ' ' ' ' | cut -f-30 -d' ' $textFile > $textFileAnt
	textFile=$textFileAnt
elif [ $zone == 'post' ]
then
	textFilePost=$input'_post.txt'
	tr -s  ' ' ' ' | cut -f31- -d' '  $textFile > $textFilePost
	textFile=$textFilePost
fi


# somme de chaque ligne == nbre contact on , sortie en float
cat $textFile | awk '
{
	nbOn = 0
	for(i=1; i <= NF ; i++)
		nbOn += $i
	if ( '$format' == "pc" )
	{
		nbOn = ((nbOn/62)*100);
	}

	print nbOn
	
}' |casnu f > $output




#		  
#-------------------------
# Output descriptor
#-------------------------
fsize=$(stat -c%s "$output")
datacount=$(($fsize / 4))
rate=$((1000 / $step))

{
echo "[CODING]"
echo "CODING_version="$cmdVersion
echo "[SETTINGS]"
echo "DATA_NAME=Epg_Contact_On"
echo "DATA_TYPE=temporal_serie"
echo "DATA_VAR_FORMAT=float_intel"
echo "ACRONYM=epg_contact_on"
echo "DATA_COUNT="$datacount
#echo "FRAME_SIZE="$size
echo "SAMPLING_PERIOD="$step  # 4 ms en principe
#echo "SAMPLING_PERIOD=4"
echo "SAMPLING_RATE="$rate
echo "format="$format
echo "[SCALE]"
echo "UNIT=nb_contact_on"
echo "[INFO]"
echo "SOURCE="$input
echo "SRC_RATE="$sampling
echo "CREATION_DATE="$(date)
echo "SOFTWARE="$cmdName $cmdVersion
echo "COPYRIGHT=Copyright  2010 - LPL"
#echo "OPTIONS=-frameStepMs "$step
echo "COMMAND=" $cmdName $lcmd
} > $output.dsc