#!/bin/bash


#-------------------------
cmdName=SignaixF0Comb
cmdVersion="1.0.0.0 2010-04-20"
#-------------------------

#-------------------------
cmdhelp()
{
$PHONEDITPATH/plugins/DlgPrompt.exe "cmdname -F fech [-p step]"
echo ""
echo "cmdname -F fech [-p step]"
echo ""
}>/dev/stderr
#-------------------------

#-------------------------
error()
{
$PHONEDITPATH/plugins/DlgPrompt.exe "Syntax error : $errmsg"
echo ""
echo "Syntax error : $errmsg"
cmdhelp

} >/dev/stderr
#-------------------------

#-------------------------
function resampling()
{
input=$1
newS=$2
inputRS=$input'_RSpeig'		#cration d'un fichier inputRS qui sera utilis comme fichier input dans la suite du script

chemin=C:'/Program Files/phonedit/plugins'
"$chemin/resampling.sh" -input $input -output $inputRS -ns $newS

}


#-------------------------
# Arguments analysis
#-------------------------
lcmd=$@
step=10
while test "X$1" != X
do
   case $1 in
    -in*)  input="$2" ; shift 2 ;;
   -out*) output="$2" ; shift 2 ;;
   -F) sampling=$2 ; shift 2 ;;
   -p|-frameStepMs) step=$2 ; shift 2 ;;
   -f|-frameSizeMs) size=$2 ; shift 2 ;;
   -help|-h|-sos|-aide) cmdhelp ; exit 0 ;;
   -*)         errmsg="Unknown Argument $1" ; error; exit 1 ;;
   esac
done

#-------------------------
# Input descriptor
#-------------------------
dsc_input=$input.dsc
if test  ! -f "$dsc_input"
then
  echo "Descriptor file $dsc_input non available" >/dev/stderr
  cmdhelp
  exit 1
fi

sampling=$(GetParamFromDesc SAMPLING_RATE < "$dsc_input")

#-------------------------
# ReSampling
#-------------------------
inputRS=$input

# La frquence d'chantillonnage doit tre gale  16000, sinon on rchantillonne
if [ $sampling != 16000 ]
then
resampling $input 16000 
fi

#-------------------------
# JOB
#-------------------------

function calcul
{
#typeset  s ec
#integer ret
#integer bloc_ec bloc_sec fech taille_ec pas_ec taille_fic rang correction 
#integer marge_sec limite xreste

bloc_sec=40
marge_sec=2  #evite de laisser trop peu de signal sur la fin

taille_ec=2
le_reste=9999999

fech=$1
# echantillons bruts
ec=$2


#
# on redirige sur la SS la sortie erreur du bloc { }
# si vide (?  plutot ==0 )  RAS, sinon PB
    {
       {
        echo 0 0 |casnu f     #correction decalage de 2 trames
   		
       set -- $(ls -lL $ec)  #suit le lien eventuel
       taille_fic=$(($5 / $taille_ec))
	   
       bloc_ec=$(( $fech* $bloc_sec ))
       pas_ec=$(( ($fech* $step) /1000 ))
	  
       correction=$pas_ec
       limite=$(( $taille_fic - $fech*$marge_sec ))
	   
       rang=0
	
       {
       while (( $rang < $limite ))
       do  
              dds $ec $taille_ec $rang $bloc_ec |vnud F$fech 
              rang=$(( $rang+ $bloc_ec- $correction ))
       done  
       
       xreste=$(dds $ec $taille_ec $rang $le_reste|wc -c)
#       print "sortie sur rang $rang reste $xreste" >/dev/stderr
       if test $xreste -gt 0
       then
           dds $ec $taille_ec $rang $le_reste |vnud F$fech
       fi
       }   |peig F$fech |pof |fmedian 3 

       }  > $output
          
       ret=$?  #TRES insuffisant ($? de fmedian)

       set -- $(ls -l $output ) ; nb_oct=$5
       if (( $nb_oct < 12 ))
       then
           echo "$output not created"
           ret=2
       fi
    } 2>& 1
return $ret    
}

# err != 0   echec de detection

err=$( calcul 16000 $inputRS )

#rm $inputRS

#-------------------------
# Output descriptor
#-------------------------
fsize=$(stat -c%s "$output")
datacount=$(( $fsize / 4))
NChannels=$(GetParamFromDesc SRC_NCHANNELS < "$dsc_input")
BitSampleSize=$(GetParamFromDesc SRC_BITSPERSAMPLE < "$dsc_input")

{
echo "[CODING]"
echo "CODING_version="$cmdVersion
echo "[SETTINGS]"
echo "DATA_NAME=F0 Comb"
echo "DATA_TYPE=temporal_serie"
echo "DATA_VAR_FORMAT=float_intel"
echo "ACRONYM='f0  '"
echo "DATA_COUNT="$datacount
echo "FRAME_SIZE="$size
echo "SAMPLING_PERIOD="$step
#echo "SAMPLING_RATE="$newS
echo "[SCALE]"
echo "UNIT=Hz"
echo "[INFO]"
echo "SOURCE="$input
echo "SRC_RATE="$sampling
echo "SRC_BITSPERSAMPLE="$BitSampleSize
echo "SRC_NCHANNELS="$NChannels
echo "CREATION_DATE="$(date)
echo "SOFTWARE="$cmdName $cmdVersion
echo "COPYRIGHT=Copyright  2010 - LPL"
echo "OPTIONS=-frameSizeMS "$size" -frameStepMS "$step
echo "COMMAND=" $cmdName $lcmd
} > $output.dsc
