#!/bin/bash

trap 'rm -f /tmp/vote*$$;exit $code_retour ' 0 1 2 15


##########################
#  ATTENTION     Modif du PATH pour ce script
PATH=$PATH:$PHONEDITPATH/plugins


#-------------------------
cmdName=SignaixF0Vote
cmdVersion="1.0.0.0 2010-04-20"
#-------------------------

#-------------------------
cmdhelp()
{
$PHONEDITPATH/plugins/DlgPrompt.exe "Syntax error : $errmsg"
echo ""
echo "$cmdName -input signal -output f0data "
echo ""
} >/dev/stderr
#-------------------------

#-------------------------
error()
{
echo ""
echo "Syntax error : $errmsg"
cmdhelp

} >/dev/stderr
#-------------------------

#-------------------------
function resampling () {
input=$1
newS=$2
inputRS=$input'_RSvote'		#cration d'un fichier inputRS qui sera utilis comme fichier input dans la suite du script

resampling.sh -input $input -output $inputRS -ns $newS
}


#-------------------------
# Arguments analysis
#-------------------------
lcmd=$@

median=3
step=10

trace=0
seuil_diverge='0.05'


while test "X$1" != X
do
   case $1 in
   -in*)  input="$2" ; shift 2 ;;
   -out*) output="$2" ; shift 2 ;;
   -p|-frameStepMs) step=$2 ; shift 2 ;;
   -f|-frameSizeMs) size=$2 ; shift 2 ;;
   -help|-h|-sos|-aide) cmdhelp ; exit 0 ;;
   -*)         errmsg="Unknown Argument $1" ; error; exit 1 ;;
   esac
done

#-------------------------
# Input descriptor
#-------------------------
dsc_input=$input.dsc
if test  ! -f "$dsc_input"
then
  echo "Descriptor file $dsc_input non available" >/dev/stderr
  cmdhelp
  exit 1
fi

sampling=$(GetParamFromDesc SAMPLING_RATE < "$dsc_input")

#-------------------------
# ReSampling
#-------------------------
inputRS=$input

# La frquence d'chantillonnage doit tre gale  16000, sinon on rchantillonne
if [ $sampling != 16000 ]
then
resampling $input 16000
fi


#-------------------------
# JOB
#-------------------------

# PATH est configure ds bash_profile

SignaixF0AMDF.sh -input $inputRS  -output ${output}.amdf
#cp ${output}.amdf $output 

SignaixF0Comb.sh -input $inputRS  -output ${output}.peigne
#cp ${output}.peigne $output 

SignaixF0Autoc.sh -input $inputRS  -output ${output}.autoc
#cp ${output}.autoc  $output

 function colle
{
ta=/tmp/votea$$
tb=/tmp/voteb$$
  cnuas f <$1 >$ta
  cnuas f <$2 >$tb
  cnuas f <$3 | paste $ta $tb - |tee $HOME/TRACEcolle
}

{
	echo 0
	colle ${output}.amdf ${output}.autoc ${output}.peigne  \
		| awk '

	########
	function abs(val) {
	if (val < 0)
	   val = -val
	return val
	}

	############
	function mediane(v,nmet,   i,ip1,j,nclass,temp,vtemp) {

	for(i=1; i <= nmet; i++)
	{
		vtemp[i] = v[met[i]]
	}
		
	nclass = int(nmet/2) +1
	for (i=1; i <= nclass; i++)
	{
		ip1 = i+1
		for(j=ip1; j <= nmet; j++)
		{
			if (vtemp[j] > vtemp[i] )
			{
				temp = vtemp[i]
				vtemp[i] = vtemp[j]
				vtemp[j] = temp
			}
		}
	}

	return (vtemp[nclass])
	}


	########################  maitre awk

	 BEGIN {
				trace='$trace'
				#seg="'$s'"
# sert seulemnt a conderver le nom des methodes 
# suppos etre pour chaque ligne ds lordre amd autoc peig
				  met[1]="f0amdf"
				  met[2]="f0autoc"
				  met[3]="f0peig"

			nmet=3
					 
			seuil_diverge='$seuil_diverge'

			 NVOISE=0
			stable="stable"
			propose="propose"
			vrai=1
			faux=0		
			}


	NF==nmet   {

				 for(i=1 ; i<= NF; i++)
				 {
					vihz = int($i +0.5)       
					valhz[met[i]] = vihz
					tabhz[NR,i] = vihz
			  }     			
						  
		val_mediane = mediane(valhz, nmet)
	#	print "mediane",  val_mediane > "/dev/tty"
		if (val_mediane == 0)
		{
			val_propose = NVOISE
			status[NR,stable] = vrai
		}
		else
		{    				  

				drel[0] = 1
				drel[1] = 1
				drel[2] = 1
					
				d[0]=abs(valhz[met[1]] - valhz[met[2]])
				if(valhz[met[1]] != 0)
						 drel[0] = d[0]/valhz[met[1]]

				d[1]=abs(valhz[met[2]] - valhz[met[3]])
				if(valhz[met[2]] != 0)
						 drel[1] = d[1]/valhz[met[2]]
					
				d[2]=abs(valhz[met[1]] - valhz[met[3]])
				if(valhz[met[1]] != 0)
						 drel[2] = d[2]/valhz[met[1]]

				dmin=999999
				for(i=0; i<3 ;i++)
				{
						  if(d[i] <dmin)
						  {
						  dmin=d[i]
						  imin=i
						  }
				}
					
				   
				if (drel[imin] <= seuil_diverge)
				{
					
				   if  (imin==0)
				   {
						   val_propose = ($1+$2)/2 
					}
					else if (imin==1)  
					{
						   val_propose = ($2+$3)/2                 	  
					}
					else
					{
						 val_propose = ($1+$3)/2
					}
					 
				   status[NR,stable] = vrai	 
				   
				}    # fin cas convergence
				else
				{  
					 val_propose = val_mediane
			status[NR,stable] = faux           
			}
			   
			 } #fin bloc cas mediane != 0 

		 
		status[NR,propose] = val_propose
	}
	##### fin bloc sur chaque ligne

	####### 2eme passage  pour correction eventuelle zones instables

	############# fonctions pour bloc END
	#########
	function  zone_stable_gauche(debut_rec,	i,l) {
		i=debut_rec -1
		l=0
		while (l < seuil_duree_stable && i >=1 && status[i,propose] != NVOISE && status[i,stable] == vrai)
		{
			i-- ; l++
		}
		return(l)
	}     

	#########
	function  zone_stable_droite(debut_rec,	i,l) {
		i=debut_rec +1
		l=0
		while (l < seuil_duree_stable && i <= NR && status[i,propose] != NVOISE && status[i,stable] == vrai )
		{
			i++ ; l++
		}
		return(l)
	}

	#########
	function corrige_gauche(ancre0, debut_z, fin_z,   i,a,v)
	{
		a=ancre0
		for(i=debut_z; i <= fin_z; i++)
		{
			v = plus_proche(a, tabhz, i)
			status[i, propose] = v 	
			a = v
		}
			
	}

	##########
	function corrige_droite(ancre0, debut_z, fin_z,   i,a,v)
	{
		a=ancre0
		for(i=fin_z; i >= debut_z; i--)
		{
			v = plus_proche(a, tabhz, i)
			status[i, propose] = v 	
			a = v
		}
	}

	##########
	function plus_proche(ancre,tabhz,itrame,   i,d,dmin,imin)
	{
		dmin=9999
		for(i=1; i <= nmet; i++)
		{
			if (tabhz[itrame,i] != NVOISE)
			{
				d= abs(tabhz[itrame,i] -ancre)
				if (d < dmin)
				{
					dmin = d
					imin = i
				}
			}
		}
		
		return(tabhz[itrame,imin])
	}


	########## maitre END
	END {

	etat_instable=1
	etat_non_instable=0
	etat_instable_fin=2

	#en trames
	seuil_duree_stable=7
	seuil_duree_correction_instable=10

	if (trace)
	{
	   fic=seg "/TRACE_STATUS"
	   for(i=1; i <= NR; i++)
		 print i,tabhz[i,1] ,tabhz[i,2] , tabhz[i,3], status[i,stable], status[i,propose] > fic
	}


	#recherche zones instables: correction si 
	#  <seuil_correction_instable  et 
	# voisins gauche et/ou droit stable >seuil_dure_stable  (en trames)

	idepart=1
	i=idepart
	etat=etat_non_instable

	while ( i <= NR )
	{
		if (etat == etat_non_instable)
		{
			if (status[i,stable] == faux)
			{
				etat = etat_instable
				debut_div=i
				i++ ; continue
			}
			else
				i++ ; continue
				
		}

		else if (etat == etat_instable)
		{
			if (status[i,stable] == vrai)
			{
				etat = etat_instable_fin
				fin_div = i-1
				continue
				
			}
			else
				i++ ; continue
		}

		else if (etat ==  etat_instable_fin)
		{
			# on a une zone instable [debut_div, fin_div]
			if(trace)
			{
				fic=seg "/TRACE_ZONE_INSTABLE"
				print "instable ", debut_div, fin_div  >fic
			}
			
			if ( fin_div - debut_div +1 <= seuil_duree_correction_instable)
			{
				lg = zone_stable_gauche(debut_div)		
				ld = zone_stable_droite(fin_div)
				if ( lg >= seuil_duree_stable || ld >= seuil_duree_stable)
				{
					if (lg >= ld)
					{
						ancre = status[debut_div -1,propose]
						corrige_gauche(ancre, debut_div, fin_div)
					}
					else
					{
						ancre = status[fin_div +1,propose]
						corrige_droite(ancre, debut_div, fin_div)
					}
				
				 }	#fin bloc if choix gauche/droite
			 } #fin bloc if correction
			
			etat = etat_non_instable
			i = fin_div +1 ; continue
		 }
	} #fin du while

	#sortie du resultat
	for(i=1; i <= NR; i++)
		print status[i,propose]  

	#fin bloc END  et du script awk
	 }
	'

} |casnu f > $output
	
	
#		  
#-------------------------
# Output descriptor
#-------------------------
fsize=$(stat -c%s "$output")
datacount=$(($fsize / 4))
NChannels=$(GetParamFromDesc SRC_NCHANNELS < "$dsc_input")
BitSampleSize=$(GetParamFromDesc SRC_BITSPERSAMPLE < "$dsc_input")

{
echo "[CODING]"
echo "CODING_version="$cmdVersion
echo "[SETTINGS]"
echo "DATA_NAME=F0 AMDF+Autoc+Comb"
echo "DATA_TYPE=temporal_serie"
echo "DATA_VAR_FORMAT=float_intel"
echo "ACRONYM='f0  '"
echo "DATA_COUNT="$datacount
echo "FRAME_SIZE="$size
echo "SAMPLING_PERIOD="$step
#echo "SAMPLING_RATE="$newS
echo "[SCALE]"
echo "UNIT=Hz"
echo "[INFO]"
echo "SOURCE="$input
echo "SRC_RATE="$sampling
echo "SRC_BITSPERSAMPLE="$BitSampleSize
echo "SRC_NCHANNELS="$NChannels
echo "CREATION_DATE="$(date)
echo "SOFTWARE="$cmdName $cmdVersion
echo "COPYRIGHT=Copyright  2010 - LPL"
echo "OPTIONS=-frameStepMs "$step
echo "COMMAND=" $cmdName $lcmd
} > $output.dsc


