#!/bin/bash


#-------------------------
cmdName=SignaixIRMS
cmdVersion="1.0.0.0 2008-05-28"
#-------------------------

#-------------------------
cmdhelp()
{
echo ""
echo "$cmdName -input signal -output rmsdata -frameSizeMs ms -frameStepMs ms"
echo ""
}>/dev/stderr
#-------------------------

#-------------------------
error()
{
$PHONEDITPATH/plugins/DlgPrompt.exe "Syntax error : $errmsg"
echo ""
echo "Syntax error : $errmsg"
cmdhelp

} >/dev/stderr


#-------------------------
# Arguments analysis
#-------------------------
lcmd=$@
size=10.0
step=10.0
while test "X$1" != X
do
   case $1 in
   -in*)  input="$2" ; shift 2 ;;
   -out*) output="$2" ; shift 2 ;;
   -f|-frameSizeMs) size=$2 ; shift 2 ;;
   -p|-frameStepMs) step=$2 ; shift 2 ;;
   -help|-h|-sos|-aide) cmdhelp ; exit 0 ;;
   -*)         errmsg="Unknown Argument $1" ; error; exit 1 ;;
   esac
done

#-------------------------
# Input descriptor
#-------------------------
dsc_input=$input.dsc
if test  ! -f "$dsc_input"
then
  echo "Descriptor file $dsc_input non available" >/dev/stderr
  exit 1
fi

sampling=$(GetParamFromDesc SAMPLING_RATE < "$dsc_input")

#-------------------------
# JOB
#-------------------------
{
cat $input | \
      irms  F$sampling f$size p$step
#	  echo 0 |casnu f 
	  
} > $output

#-------------------------
# Output descriptor
#-------------------------
fsize=$(stat -c%s "$output")
datacount=$(( $fsize / 4))
NChannels=$(GetParamFromDesc SRC_NCHANNELS < "$dsc_input")
BitSampleSize=$(GetParamFromDesc SRC_BITSPERSAMPLE < "$dsc_input")

{
echo "[CODING]"
echo "CODING_version="$cmdVersion
echo "[SETTINGS]"
echo "DATA_NAME=RMS Intensity"
echo "DATA_TYPE=temporal_serie"
echo "DATA_VAR_FORMAT=float_intel"
echo "ACRONYM='int '"
echo "DATA_COUNT="$datacount
echo "FRAME_SIZE="$size
echo "SAMPLING_PERIOD="$step
echo "[SCALE]"
echo "UNIT=dB"
echo "[INFO]"
echo "SOURCE="$input
echo "SRC_RATE="$sampling
echo "SRC_BITSPERSAMPLE="$BitSampleSize
echo "SRC_NCHANNELS="$NChannels
echo "CREATION_DATE="$(date)
echo "SOFTWARE="$cmdName $cmdVersion
echo "COPYRIGHT=Copyright  2007 - LPL"
echo "OPTIONS=-frameSizeMs "$size" -frameStepMs "$step
echo "COMMAND=" $cmdName $lcmd
} > $output.dsc


